using System.Collections.ObjectModel;

using Microsoft.UI.Xaml.Controls;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region Ž ׸ ÷ - ExplorerItemCollection

    /// <summary>
    /// Ž ׸ ÷
    /// </summary>
    public ObservableCollection<ExplorerItem> ExplorerItemCollection { get; }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        ExplorerItemCollection = GetExplorerItemCollection();
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Ž ׸ ÷ ϱ - GetExplorerItemCollection()

    /// <summary>
    /// Ž ׸ ÷ ϱ
    /// </summary>
    /// <returns>Ž ׸ ÷</returns>
    private ObservableCollection<ExplorerItem> GetExplorerItemCollection()
    {
        ObservableCollection<ExplorerItem> collection = new ObservableCollection<ExplorerItem>();

        ExplorerItem explorerItem1 = new ExplorerItem()
        {
            Name                        = "Work Documents",
            ChildExplorerItemCollection =
            {
                new ExplorerItem()
                {
                    Name                        = "Functional Specifications",
                    ChildExplorerItemCollection =
                    {
                        new ExplorerItem()
                        {
                            Name = "TreeView spec"
                        }
                    }
                },
                new ExplorerItem()
                {
                    Name = "Feature Schedule"
                },
                new ExplorerItem()
                {
                    Name = "Overall Project Plan"
                },
                new ExplorerItem()
                {
                    Name = "Feature Resources Allocation"
                }
            }
        };

        ExplorerItem explorerItem2 = new ExplorerItem()
        {
            Name                        = "Personal Folder",
            ChildExplorerItemCollection =
            {
                new ExplorerItem()
                {
                    Name                        = "Home Remodel Folder",
                    ChildExplorerItemCollection =
                    {
                        new ExplorerItem()
                        {
                            Name = "Contractor Contact Info"
                        },
                        new ExplorerItem()
                        {
                            Name = "Paint Color Scheme"
                        },
                        new ExplorerItem()
                        {
                            Name = "Flooring Woodgrain type"
                        },
                        new ExplorerItem()
                        {
                            Name = "Kitchen Cabinet Style"
                        }
                    }
                }
            }
        };

        collection.Add(explorerItem1);
        collection.Add(explorerItem2);

        for(int i = 0; i < 40; i++)
        {
            collection.Add(new() { Name = $"Folder {i + 1}" });
        }

        return collection;
    }

    #endregion
}